Unmarshaller.Listener (Java SE 10 & JDK 10 )
Keywords: javax.xml.bind.Unmarshaller.Listener class

Module java.xml.bind
Package javax.xml.bind

## Class Unmarshaller.Listener

- java.lang.Object
- - javax.xml.bind.Unmarshaller.Listener

- Enclosing interface:
    Unmarshaller

      public abstract static class Unmarshaller.Listener
      extends Object

  Register an instance of an implementation of this class with `Unmarshaller` to externally listen for unmarshal events.

  This class enables pre and post processing of an instance of a JAXB mapped class as XML data is unmarshalled into it. The event callbacks are called when unmarshalling XML content into a JAXBElement instance or a JAXB mapped class that represents a complex type definition. The event callbacks are not called when unmarshalling to an instance of a Java datatype that represents a simple type definition.

  External listener is one of two different mechanisms for defining unmarshal event callbacks. See Unmarshal Event Callbacks for an overview.

  (@link #setListener(Listener)} (@link #getListener()}
  Since:
    1.6, JAXB 2.0

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Listener()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `afterUnmarshal​(Object target, Object parent)` | Callback method invoked after unmarshalling XML data into `target`.
    `void` | `beforeUnmarshal​(Object target, Object parent)` | Callback method invoked before unmarshalling into `target`.

    - ### Methods declared in class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Listener

          public Listener()

  - ### Method Detail

    - #### beforeUnmarshal

          public void beforeUnmarshal​(Object target,
                                      Object parent)

      Callback method invoked before unmarshalling into `target`.

      This method is invoked immediately after `target` was created and before the unmarshalling of this object begins. Note that if the class of `target` defines its own `beforeUnmarshal` method, the class specific callback method is invoked before this method is invoked.

      Parameters:
        `target` - non-null instance of JAXB mapped class prior to unmarshalling into it.
        `parent` - instance of JAXB mapped class that will eventually reference `target`. `null` when `target` is root element.

    - #### afterUnmarshal

          public void afterUnmarshal​(Object target,
                                     Object parent)

      Callback method invoked after unmarshalling XML data into `target`.

      This method is invoked after all the properties (except IDREF) are unmarshalled into `target`, but before `target` is set into its `parent` object. Note that if the class of `target` defines its own `afterUnmarshal` method, the class specific callback method is invoked before this method is invoked.

      Parameters:
        `target` - non-null instance of JAXB mapped class prior to unmarshalling into it.
        `parent` - instance of JAXB mapped class that will reference `target`. `null` when `target` is root element.